_G.SimpleRP = _G.SimpleRP or {}
SimpleRP._path = ModPath
SimpleRP._data_path = SavePath .. "SimpleRP_Config.json"
SimpleRP._data = {}

function SimpleRP:Save()
	local file = io.open(self._data_path, "w")
	if file then
		file:write(json.encode(self._data))
		file:close()
	end
end

function SimpleRP:Load()
	local file = io.open(self._data_path, "r")
	
	if file then
		self._data = json.decode(file:read("*all"))
		file:close()
	end
	if not file then
		SimpleRP._data.SimpleRP_time_enable = true
		SimpleRP._data.SimpleRP_language = 1
		SimpleRP._data.SimpleRP_state_enable = true
		SimpleRP:Save()
	end
end

function SimpleRP:Refresh()
	if Global.game_settings.permission ~= "private" then
			if managers.platform then
				managers.platform:set_rich_presence()
			end
		end
end

Hooks:AddHook("LocalizationManagerPostInit" , "LocalizationManagerPostInit_SimpleRP", function(loc)
	loc:load_localization_file(SimpleRP._path .. "loc/en.txt")
end)

Hooks:AddHook("MenuManagerInitialize", "MenuManagerInitialize_SimpleRP", function(menu_manager)
	
	--SimpleRP
	MenuCallbackHandler.SimpleRP_time_enable_callback = function(self, item)
		SimpleRP._data.SimpleRP_time_enable  = (item:value() == "on" and true or false)
		SimpleRP:Save()
		SimpleRP:Refresh()
	end
	MenuCallbackHandler.SimpleRP_language_callback = function(self, item)
		SimpleRP._data.SimpleRP_language = item:value()
		SimpleRP:Save()
		SimpleRP:Refresh()
	end
	MenuCallbackHandler.SimpleRP_state_enable_callback = function(self, item)
		SimpleRP._data.SimpleRP_state_enable  = (item:value() == "on" and true or false)
		SimpleRP:Save()
		SimpleRP:Refresh()
	end
	
	SimpleRP:Load()
	MenuHelper:LoadFromJsonFile(SimpleRP._path .. "menu/options.json", SimpleRP, SimpleRP._data)
end)

--SimpleRP Func
function SimpleRP:GetSimpleRP_time()
	return SimpleRP._data.SimpleRP_time_enable
end
function SimpleRP:GetSimpleRP_language()
	return SimpleRP._data.SimpleRP_language
end
function SimpleRP:GetSimpleRP_state()
	return SimpleRP._data.SimpleRP_state_enable
end
