_G.SimpleRP_Timer_h = ""
_G.SimpleRP_Timer_m = ""
_G.SimpleRP_State = ""
_G.SimpleRP_Wave = ""

if string.lower(RequiredScript) == "lib/managers/hud/hudheisttimer" then
	function HUDHeistTimer:set_time(time)
		local inverted = false

		if time < 0 then
			inverted = true
			time = math.abs(time)
		end

		if not self._enabled or not inverted and math.floor(time) < self._last_time then
			return
		end
		
		local time_old = self._last_time
		local minutes_old = math.floor(time_old / 60)
		
		self._last_time = time
		time = math.floor(time)
		local hours = math.floor(time / 3600)
		time = time - hours * 3600
		local minutes = math.floor(time / 60)
		time = time - minutes * 60
		local seconds = math.round(time)
		local text = hours > 0 and (hours < 10 and "0" .. hours or hours) .. ":" or ""
		local text = text .. (minutes < 10 and "0" .. minutes or minutes) .. ":" .. (seconds < 10 and "0" .. seconds or seconds)

		self._timer_text:set_text(text)
		
		_G.SimpleRP_Timer_h = hours
		_G.SimpleRP_Timer_m = minutes
		
		if Global.game_settings.permission ~= "private" then
			if minutes ~= minutes_old then
				if managers.platform then
					managers.platform:set_rich_presence()
				end
			end
			
			if managers.groupai then
				if managers.groupai:state():whisper_mode() == true then
					if _G.SimpleRP_State ~= _G._G.SimpleRP_Others[9] then
						_G.SimpleRP_State = _G._G.SimpleRP_Others[9]
						if managers.platform then
							managers.platform:set_rich_presence()
						end
					end
				else
					if _G.SimpleRP_State ~= _G._G.SimpleRP_Others[10] then
						_G.SimpleRP_State = _G._G.SimpleRP_Others[10]
						if managers.platform then
							managers.platform:set_rich_presence()
						end
					end
				end
			end
			
			if managers.skirmish and managers.skirmish:is_skirmish() then
				local srp_wave_nr = managers.skirmish:current_wave_number()
					if srp_wave_nr == nil then
						srp_wave_nr = 0
					end
				
				if _G.SimpleRP_Wave == "" then
					_G.SimpleRP_Wave = srp_wave_nr
				end
				
				if _G.SimpleRP_Wave ~= managers.skirmish:current_wave_number() then
					_G.SimpleRP_Wave = managers.skirmish:current_wave_number()
					if managers.platform then
						managers.platform:set_rich_presence()
					end
				end
			end
			
		end
		
	end
end

if not _G.SimpleRP_Lobby then
			_G.SimpleRP_Lobby = {}
			local _path = ModPath .. "random_lobby.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("Chilling in Lobby: \n")
				file:write("Waiting in Lobby: \n")
				file:write("Bored in Lobby: \n")
				file:write("Chatting in Lobby: \n")
				file:write("Set Skillpoints in Lobby: \n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Lobby, line)
				end
			file:close()
			end
end
if not _G.SimpleRP_Playing then
			_G.SimpleRP_Playing = {}
			local _path = ModPath .. "random_playing.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("Running away from a cloaker in: \n")
				file:write("Playing: \n")
				file:write("Being carried in: \n")
				file:write("Killing cops in: \n")
				file:write("Having fun in: \n")
				file:write("Trying to survive in: \n")
				file:write("Crushed by bulldozers in: \n")
				file:write("Swings guns in: \n")
				file:write("Stumbles through the mission: \n")
				file:write("Defends drills in: \n")
				file:write("Nods head to the music in: \n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Playing, line)
				end
			file:close()
			end
end
if not _G.SimpleRP_Payday then
			_G.SimpleRP_Payday = {}
			local _path = ModPath .. "random_payday.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("Payday: \n")
				file:write("Finally over: \n")
				file:write("Get XP: \n")
				file:write("Mission complete: \n")
				file:write("Mission done: \n")
				file:write("Get XP & Money: \n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Payday, line)
				end
			file:close()
			end
end
if not _G.SimpleRP_Planning then
			_G.SimpleRP_Planning = {}
			local _path = ModPath .. "random_planning.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("Creates a Masterplan: \n")
				file:write("Draws funny things in Planning: \n")
				file:write("Planning: \n")
				file:write("Waiting for ready in Planning: \n")
				file:write("Buys things in Planning: \n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Planning, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_MainMenu then
			_G.SimpleRP_MainMenu = {}
			local _path = ModPath .. "random_mainmenu.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("At the main menu\n")
				file:write("Waiting in main menu\n")
				file:write("Looking around the main menu\n")
				file:write("In main menu\n")
				file:write("No lobby yet!\n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_MainMenu, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Private then
			_G.SimpleRP_Private = {}
			local _path = ModPath .. "random_private.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("In a private lobby\n")
				file:write("Hey don't spy on me\n")
				file:write("What are you looking at here?\n")
				file:write("There's nothing to see here!\n")
				file:write("Look away! it is private :)\n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Private, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Players then
			_G.SimpleRP_Players = {}
			local _path = ModPath .. "random_players.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("Players\n")
				file:write("Noobs\n")
				file:write("Plebs\n")
				file:write("Friends\n")
				file:write("Homies\n")
				file:write("Buddies\n")
				file:write("Mates\n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Players, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Difficulties then
			_G.SimpleRP_Difficulties = {}
			local _path = ModPath .. "text_difficulties.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("(EASY)\n")
				file:write("(NORMAL)\n")
				file:write("(HARD)\n")
				file:write("(VERY HARD)\n")
				file:write("(OVERKILL)\n")
				file:write("(MAYHEM)\n")
				file:write("(DEATHWISH)\n")
				file:write("(DEATH SENTENCE)\n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Difficulties, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Others then
			_G.SimpleRP_Others = {}
			local _path = ModPath .. "text_others.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("[CS]\n")
				file:write("Lvl.\n")
				file:write("[HO]\n")
				file:write("Wave\n")
				file:write("Day\n")
				file:write("h\n")
				file:write("m\n")
				file:write("| Time: \n")
				file:write("| Stealth\n")
				file:write("| Loud\n")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Others, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Sequence then
			_G.SimpleRP_Sequence = {}
			local _path = ModPath .. "sequence_heist.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("$HEIST $DAY $DIFFICULTY $PLAYERS $TIME $STATE")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Sequence, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Sequence_CS then
			_G.SimpleRP_Sequence_CS = {}
			local _path = ModPath .. "sequence_crimespree.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("$CS $HEIST ($LVL) $PLAYERS $TIME $STATE")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Sequence_CS, line)
				end
			file:close()
			end
end

if not _G.SimpleRP_Sequence_HO then
			_G.SimpleRP_Sequence_HO = {}
			local _path = ModPath .. "sequence_holdout.ini"
			local path = _path:gsub( "/lua", "")
			local file, err = io.open(path, "r")
			if not file then
				file = io.open(path, "w")
				file:write("$HO $HEIST ($WAVE) $PLAYERS $TIME")
				file:close()
			end
			local file, err = io.open(path, "r")
			if file then
				for line in file:lines() do
				table.insert(_G.SimpleRP_Sequence_HO, line)
				end
			file:close()
			end
end

if RequiredScript == "lib/managers/platformmanager" then
	core:module("PlatformManager")

	local set_rich_presence_original = WinPlatformManager.set_rich_presence
	function WinPlatformManager:set_rich_presence(name, ...)
		set_rich_presence_original(self, name or self._current_rich_presence, ...)

		if SystemInfo:distribution() == Idstring("STEAM") then
			-- Default config
			local display = "#raw_status" --"#DisplayMe"
			local group_key = ""
			local group_count = ""

			local game_state = "menu"
			local game_mode = ""
			local game_heist = ""
			local game_heistday = ""
			local game_difficulty = ""
			
			local player = managers.player:local_player()
			
			if self._current_rich_presence ~= "Idle" then
				if Global.game_settings.permission == "private" and not Global.game_settings.single_player then
					game_state = "private"
				else
					-- Handle Steam RP Grouping
					if not Global.game_settings.single_player then
						if managers.network.matchmake and managers.network.matchmake.lobby_handler then
							group_key = managers.network.matchmake.lobby_handler:id()
						end

						local session = managers.network:session()
						group_count = tostring(session and #session:all_peers() or 1)
					end

					-- Determine game state
					if _G.game_state_machine and (_G.game_state_machine:current_state_name() == "menu_main" or _G.game_state_machine:current_state_name() == "ingame_lobby_menu") then
						if _G.SimpleRP_Timer_m == "" then
							game_state = "lobby"
						else
							game_state = "payday"
						end
					elseif self._current_rich_presence == "SPEnd" or self._current_rich_presence == "MPEnd" then
						game_state = "payday"
					elseif self._current_rich_presence == "SPPlaying" or self._current_rich_presence == "MPPlaying" then
						if alive(player) or _G.SimpleRP_Timer_m ~= "" then
							game_state = "playing"
						else
							game_state = "planning"
						end
					end

					-- Popululate gamemode, heist and difficulty
					if managers.crime_spree and managers.crime_spree:is_active() then		-- Crime Spree
						game_mode = "crime_spree"
						game_heist = self:get_current_level_id()
						local spree_lvl = managers.crime_spree:server_spree_level()
						game_difficulty = spree_lvl and managers.money:add_decimal_marks_to_string(tostring(spree_lvl)) or "(N/A)"
					elseif managers.skirmish and managers.skirmish:is_skirmish() then		-- Holdout
						game_mode = "skirmish"
						game_heist = self:get_current_level_id()
						game_difficulty = string.format("%i/%i", managers.skirmish:current_wave_number() or 1, tweak_data and #tweak_data.skirmish.ransom_amounts or 9)
					elseif managers.job:has_active_job() then								-- Heists
						game_heist = self:get_current_job_id()

						if #(managers.job:current_job_chain_data() or {}) > 1 then
							game_mode = "heist_chain"
							game_heistday = tostring(managers.job:current_stage() or "")
						else
							game_mode = "heist"
						end

						game_difficulty = tweak_data and tweak_data:index_to_difficulty(managers.job:current_difficulty_stars() + 2) or Global.game_settings.difficulty or "easy"
					else
						-- Overwrite game state if nothing is selected
						game_state = "lobby_no_job"
					end
				end
			end

			-- Send our data to Steam
			Steam:set_rich_presence("steam_display", display)		-- Currently not usable, only Overkill can setup required localized strings here...
			Steam:set_rich_presence("steam_player_group", group_key)
			Steam:set_rich_presence("steam_player_group_size", group_count)

			Steam:set_rich_presence("game:state", game_state)
			Steam:set_rich_presence("game:mode", game_mode)
			Steam:set_rich_presence("game:heist", game_heist)
			Steam:set_rich_presence("game:heist_day", game_heistday)
			Steam:set_rich_presence("game:difficulty", game_difficulty)
			
			local srp_players_get = _G.SimpleRP_Players[math.random(1,(table.getn(_G.SimpleRP_Players)))]
			local srp_hour_text = _G._G.SimpleRP_Others[6]
			local srp_minute_text = _G._G.SimpleRP_Others[7]
			local srp_timer_get = _G._G.SimpleRP_Others[8]
			
			local srp_lvl_text = _G._G.SimpleRP_Others[2]
			local srp_wave_text = _G._G.SimpleRP_Others[4]
		
			local srp_text = self:build_status_string(display, game_state, game_mode, game_heist, game_heistday, game_difficulty)
			
			if not _G.SimpleRP_Players_text then
					_G.SimpleRP_Players_text = srp_players_get
				else
					srp_players_get = _G.SimpleRP_Players_text
			end
			
			if not _G.SimpleRP_Time_text then
					_G.SimpleRP_Time_text = srp_timer_get
				else
					srp_timer_get = _G.SimpleRP_Time_text
			end
			
			local srp_players_text = ""
			
			if group_count ~= "" then
				srp_players_text = " " .. group_count .. "/4 " .. srp_players_get
			end
			
			local srp_timer_text = ""
			local srp_state_text = ""
			if game_state == "playing" then
				if not _G.SimpleRP_Playing_text then
						_G.SimpleRP_Playing_text = srp_text
					else
						srp_text = _G.SimpleRP_Playing_text
				end	
				if _G.SimpleRP:GetSimpleRP_time() == true then
					if _G.SimpleRP_Timer_m ~= "" then
						srp_timer_text = srp_timer_get .. _G.SimpleRP_Timer_h .. srp_hour_text .. _G.SimpleRP_Timer_m .. srp_minute_text
					else
						srp_timer_text = srp_timer_get .. _G.SimpleRP_Timer_h .. srp_hour_text .. "0" .. _G.SimpleRP_Timer_m .. srp_minute_text
					end
				end
				if _G.SimpleRP:GetSimpleRP_state() == true then
					srp_state_text = _G.SimpleRP_State
				end
			end
			
			if game_state == "planning" then
				if not _G.SimpleRP_Planning_text then
					_G.SimpleRP_Planning_text = srp_text
				else
					srp_text = _G.SimpleRP_Planning_text
				end
			end
			
			if game_state == "payday" then
				if not _G.SimpleRP_Payday_text then
					_G.SimpleRP_Payday_text = srp_text
				else
					srp_text = _G.SimpleRP_Payday_text
				end
			end
			
			if managers.crime_spree and managers.crime_spree:is_active() then
				local spree_lvl = managers.crime_spree:server_spree_level()
				srp_text = srp_text:gsub("$LVL", srp_lvl_text .. " " .. spree_lvl)
			elseif managers.skirmish and managers.skirmish:is_skirmish() then
				local srp_wave_nr = managers.skirmish:current_wave_number()
					if srp_wave_nr == nil then
						srp_wave_nr = 0
					end
				srp_text = srp_text:gsub("$WAVE", srp_wave_text .. " " .. srp_wave_nr .. "/9")
			end
					
			local srp_filter = srp_text:gsub("$PLAYERS", srp_players_text):gsub("$TIME", srp_timer_text):gsub("$STATE", srp_state_text)
			Steam:set_rich_presence("status",  srp_filter)
		end
	end
	
	local suffixList = {
		"_prof$",
		"_day$",
		"_night$",
		"_wrapper$",
		"^skm_"
	}
	local ignoreSuffix = {
		["election_day"] = true
	}

	function WinPlatformManager:get_current_job_id()
		local job_id = managers.job:current_job_id()

		if job_id and not ignoreSuffix[job_id] then
			for _, suffix in ipairs(suffixList) do
				job_id = job_id:gsub(suffix, "")
			end
		end

		return job_id or "UNKNOWN"
	end

	function WinPlatformManager:get_current_level_id()
		local level_id = Global.game_settings.level_id

		if level_id and not ignoreSuffix[level_id] then
			for _, suffix in ipairs(suffixList) do
				level_id = level_id:gsub(suffix, "")
			end
		end

		return level_id or self:get_current_job_id()
	end

	function WinPlatformManager:build_status_string(display, state, mode, heist, day, difficulty)
		local srp_mainmenu_text = _G.SimpleRP_MainMenu[math.random(1,(table.getn(_G.SimpleRP_MainMenu)))]
		local srp_private_text = _G.SimpleRP_Private[math.random(1,(table.getn(_G.SimpleRP_Private)))]
		local srp_lobby_text = _G.SimpleRP_Lobby[math.random(1,(table.getn(_G.SimpleRP_Lobby)))]
		local srp_playing_text = _G.SimpleRP_Playing[math.random(1,(table.getn(_G.SimpleRP_Playing)))]
		local srp_payday_text = _G.SimpleRP_Payday[math.random(1,(table.getn(_G.SimpleRP_Payday)))]
		local srp_planning_text = _G.SimpleRP_Planning[math.random(1,(table.getn(_G.SimpleRP_Planning)))]
		
		local srp_cs_text = _G._G.SimpleRP_Others[1]
		local srp_ho_text = _G._G.SimpleRP_Others[3]
		local srp_day_text = _G._G.SimpleRP_Others[5]
		
		local srp_easy_text = _G._G.SimpleRP_Difficulties[1]
		local srp_normal_text = _G._G.SimpleRP_Difficulties[2]
		local srp_hard_text = _G._G.SimpleRP_Difficulties[3]
		local srp_veryhard_text = _G._G.SimpleRP_Difficulties[4]
		local srp_overkill_text = _G._G.SimpleRP_Difficulties[5]
		local srp_mayhem_text = _G._G.SimpleRP_Difficulties[6]
		local srp_deathwish_text = _G._G.SimpleRP_Difficulties[7]
		local srp_deathsentence_text = _G._G.SimpleRP_Difficulties[8]
		
		local srp_sequence_txt = _G._G.SimpleRP_Sequence[1]
		local srp_sequence_lobby_filter = srp_sequence_txt:gsub("$HEIST", ""):gsub("$DAY", ""):gsub("$DIFFICULTY", "")
		local srp_sequence_heist_filter = srp_sequence_txt:gsub("$HEIST", "{#Job_%%game:heist%%}"):gsub("$DAY", ""):gsub("$DIFFICULTY", "{#Difficulty_%%game:difficulty%%}")
		local srp_sequence_heistchain_filter = srp_sequence_txt:gsub("$HEIST", "{#Job_%%game:heist%%}"):gsub("$DAY", srp_day_text .. " %%game:heist_day%% "):gsub("$DIFFICULTY", "{#Difficulty_%%game:difficulty%%}")
		
		local srp_sequence_CS_txt = _G._G.SimpleRP_Sequence_CS[1]
		local srp_sequence_CS_filter = srp_sequence_CS_txt:gsub("$CS", srp_cs_text):gsub("$HEIST", "{#Level_%%game:heist%%}")
		
		local srp_sequence_HO_txt = _G._G.SimpleRP_Sequence_HO[1]
		local srp_sequence_HO_filter = srp_sequence_HO_txt:gsub("$HO", srp_ho_text):gsub("$HEIST", "{#Level_%%game:heist%%}")
		
		local tokens = {}
		
		if _G.SimpleRP:GetSimpleRP_language() == 1 then
			tokens = {
			["#raw_status"] =				"{#State_%game:state%}",

			-- Game states
			["#State_menu"] =				srp_mainmenu_text,
			["#State_private"] =			srp_private_text,
			["#State_lobby_no_job"] =		srp_lobby_text .. srp_sequence_lobby_filter,
			["#State_lobby"] =				srp_lobby_text .. "{#Mode_%game:mode%}",
			["#State_playing"] =			srp_playing_text .. "{#Mode_%game:mode%}",
			["#State_payday"] =				srp_payday_text .. "{#Mode_%game:mode%}",
			["#State_planning"] =			srp_planning_text .. "{#Mode_%game:mode%}",
			
			-- Game modes
			["#Mode_crime_spree"] =			srp_sequence_CS_filter,
			["#Mode_skirmish"] =			srp_sequence_HO_filter,
			["#Mode_heist"] =				srp_sequence_heist_filter,
			["#Mode_heist_chain"] =			srp_sequence_heistchain_filter,

			-- Difficulties
			["#Difficulty_easy"] =			srp_easy_text,
			["#Difficulty_normal"] =		srp_normal_text,
			["#Difficulty_hard"] =			srp_hard_tex,
			["#Difficulty_overkill"] =		srp_veryhard_text,
			["#Difficulty_overkill_145"] =	srp_overkill_text,
			["#Difficulty_easy_wish"] =		srp_mayhem_text,
			["#Difficulty_overkill_290"] =	srp_deathwish_text,
			["#Difficulty_sm_wish"] =		srp_deathsentence_text,

			["#Job_short"] = 				"The Basics",					-- Tutorials
			["#Job_short1"] = 				"Flash Drive - Stealth",
			["#Level_short1_stage1"] = 		"Stealth - Flash Drive",
			["#Level_short1_stage2"] = 		"Stealth  - Erasing History",
			["#Job_short2"] = 				"Get The Coke - Loud",
			["#Level_short2_stage1"] = 		"Loud - Get The Coke",
			["#Level_short2_stage2b"] = 	"Loud - Plan B",
			["#Job_chill"] = 				"Safe House",					-- Safe House
			["#Level_chill"] = 				"Safe House",
			["#Job_chill_combat"] = 		"Safe House Raid",
			["#Level_chill_combat"] = 		"Safe House Raid",
			["#Job_safehouse"] = 			"The Safe House",
			["#Level_safehouse"] = 			"The Safe House",
			["#Job_haunted"] = 				"Safe House Nightmare",
			["#Level_haunted"] = 			"Safe House Nightmare",
			["#Job_branchbank"] = 			"Bank Heist: Random",			-- Bank Heist
			["#Job_branchbank_gold"] = 		"Bank Heist: Gold",
			["#Job_branchbank_deposit"] = 	"Bank Heist: Deposit",
			["#Job_branchbank_cash"] = 		"Bank Heist: Cash",
			["#Level_branchbank"] = 		"Bank Heist",
			["#Job_arm"] = 					"Transport Heists",				-- Transport Heists
			["#Job_arm_und"] = 				"Transport: Underpass",
			["#Level_arm_und"] = 			"Transport: Underpass",
			["#Job_arm_hcm"] = 				"Transport: Downtown",
			["#Level_arm_hcm"] = 			"Transport: Downtown",
			["#Job_arm_cro"] = 				"Transport: Crossroads",
			["#Level_arm_cro"] = 			"Transport: Crossroads",
			["#Job_arm_for"] = 				"Transport: Train Heist",
			["#Level_arm_for"] = 			"Transport: Train Heist",
			["#Job_arm_fac"] = 				"Transport: Harbor",
			["#Level_arm_fac"] = 			"Transport: Harbor",
			["#Job_arm_par"] = 				"Transport: Park",
			["#Level_arm_par"] = 			"Transport: Park",
			["#Job_watchdogs"] = 			"Watchdogs",					-- Watchdogs
			["#Level_watchdogs_1"] = 		"Truck Load",
			["#Level_watchdogs_2"] = 		"Boat Load",
			["#Job_watchdogs_stage2"] = 	"Boat Load",
			["#Level_watchdogs_stage2"] = 	"Boat Load",
			["#Job_election_day"] = 		"Election Day",					-- Election day
			["#Level_election_day_1"] = 	"Right Track",
			["#Level_election_day_2"] = 	"Swing Vote",
			["#Level_election_day_3"] = 	"Breaking Ballot",
			["#Job_alex"] = 				"Rats",							-- Rats
			["#Level_alex_1"] = 			"Cook Off",
			["#Level_alex_2"] = 			"Code for Meth",
			["#Level_alex_3"] = 			"Bus Stop",
			["#Job_framing_frame"] = 		"Framing Frame",				-- Framing Frame
			["#Level_framing_frame_1"] = 	"Art Gallery",
			["#Level_framing_frame_2"] = 	"Train Trade",
			["#Level_framing_frame_3"] = 	"Framing",
			["#Job_firestarter"] = 			"Firestarter",					-- Firestarter
			["#Level_firestarter_1"] = 		"Airport",
			["#Level_firestarter_2"] = 		"FBI Server",
			["#Level_firestarter_3"] = 		"Trustee Bank",
			["#Job_welcome_to_the_jungle"] = 		"Big Oil",				-- Big Oil
			["#Level_welcome_to_the_jungle_1"] = 	"Club House",
			["#Level_welcome_to_the_jungle_2"] = 	"Engine Problem",
			["#Job_hox"] = 					"Hoxton Breakout",				-- Hoxton Breakout
			["#Level_hox_1"] = 				"The Breakout",
			["#Level_hox_2"] = 				"The Search",
			["#Job_mia"] = 					"Hotline Miami",				-- Hotline Miami
			["#Level_mia_1"] = 				"Hotline Miami",
			["#Level_mia_2"] = 				"Four Floors",
			["#Job_peta"] = 				"Goat Simulator",				-- Goat Simulator
			["#Level_peta"] = 				"This was not the deal",
			["#Level_peta2"] = 				"Dirty work",

			["#Job_hox_3"] = 				"Hoxton Revenge",
			["#Level_hox_3"] = 				"The Revenge",
			["#Job_mus"] = 					"The Diamond",
			["#Level_mus"] = 				"The Diamond",
			["#Job_run"] = 					"Heat Street",
			["#Level_run"] = 				"Heat Street",
			["#Job_red2"] = 				"First World Bank",
			["#Level_red2"] = 				"First World Bank",
			["#Job_born"] = 				"The Biker Heist",
			["#Level_born"] = 				"Lion's Den",
			["#Level_chew"] = 				"Interception",
			["#Job_rvd"] = 					"Reservoir Dogs Heist",
			["#Level_rvd2"] = 				"Garnet Group Boutique",
			["#Level_rvd1"] = 				"Highland Mortuary",
			["#Job_nightclub"] = 			"Nightclub",
			["#Level_nightclub"] = 			"Nightclub",
			["#Job_brb"] = 					"Brooklyn Bank",
			["#Level_brb"] = 				"Brooklyn Bank",
			["#Job_flat"] = 				"Panic Room",
			["#Level_flat"] = 				"Panic Room",
			["#Job_cage"] = 				"Car Shop",
			["#Level_cage"] = 				"Car Shop",
			["#Job_pbr2"] = 				"Birth of Sky",
			["#Level_pbr2"] = 				"Birth of Sky",
			["#Job_rat"] = 					"Cook Off",
			["#Level_rat"] = 				"Cook Off",
			["#Job_ukrainian_job"] = 		"Ukrainian Job",
			["#Level_ukrainian_job"] = 		"Ukrainian Job",
			["#Job_gallery"] = 				"Art Gallery",
			["#Level_gallery"] = 			"Art Gallery",
			["#Job_glace"] = 				"Green Bridge",
			["#Level_glace"] = 				"Green Bridge",
			["#Job_sah"] = 					"Shacklethorne Auction",
			["#Level_sah"] = 				"Shacklethorne Auction",
			["#Job_roberts"] = 				"GO Bank",
			["#Level_roberts"] = 			"GO Bank",
			["#Job_tag"] = 					"Breakin' Feds",
			["#Level_tag"] = 				"Breakin' Feds",
			["#Job_dark"] = 				"Murky Station",
			["#Level_dark"] = 				"Murky Station",
			["#Level_wwh"] = 				"Alaskan Deal",
			["#Job_wwh"] = 					"Alaskan Deal",
			["#Job_friend"] = 				"Scarface Mansion",
			["#Level_friend"] = 			"Scarface Mansion",
			["#Job_man"] = 					"Undercover",
			["#Level_man"] = 				"Undercover",
			["#Job_des"] = 					"Henry's Rock",
			["#Level_des"] = 				"Henry's Rock",
			["#Job_help"] = 				"Prison Nightmare",
			["#Level_help"] = 				"Prison Nightmare",
			["#Job_big"] = 					"The Big Bank",
			["#Level_big"] = 				"The Big Bank",
			["#Level_big2"] = 				"The Big Bank",
			["#Job_cane"] = 				"Santa's Workshop",
			["#Level_cane"] = 				"Santa's Workshop",
			["#Job_spa"] = 					"Brooklyn 10-10",
			["#Level_spa"] = 				"Brooklyn 10-10",
			["#Job_jewelry_store"] = 		"Jewelry Store",
			["#Level_jewelry_store"] = 		"Jewelry Store",
			["#Job_jolly"] = 				"Aftershock",
			["#Level_jolly"] = 				"Aftershock",
			["#Job_family"] = 				"Diamond Store",
			["#Level_family"] = 			"Diamond Store",
			["#Job_arena"] = 				"The Alesso Heist",
			["#Level_arena"] = 				"The Alesso Heist",
			["#Job_pines"] = 				"White Xmas",
			["#Level_pines"] = 				"White Xmas",
			["#Job_kenaz"] = 				"Golden Grin Casino",
			["#Level_kenaz"] = 				"Golden Grin Casino",
			["#Level_cas"] = 				"Golden Grin Casino",
			["#Job_shoutout_raid"] = 		"Meltdown",
			["#Level_shoutout_raid"] = 		"Meltdown",
			["#Job_mad"] = 					"Boiling Point",
			["#Level_mad"] = 				"Boiling Point",
			["#Job_moon"] = 				"Stealing Xmas",
			["#Level_moon"] = 				"Stealing Xmas",
			["#Job_fish"] = 				"The Yacht Heist",
			["#Level_fish"] = 				"The Yacht Heist",
			["#Job_pal"] = 					"Counterfeit",
			["#Level_pal"] = 				"Counterfeit",
			["#Job_dinner"] = 				"Slaughterhouse",
			["#Level_dinner"] = 			"Slaughterhouse",
			["#Job_pbr"] = 					"Beneath the Mountain",
			["#Level_pbr"] = 				"Beneath the Mountain",
			["#Job_crojob1"] = 				"The Bomb: Dockyard",
			["#Level_crojob2"] = 			"The Bomb: Dockyard",
			["#Job_four_stores"] = 			"Four Stores",
			["#Level_four_stores"] = 		"Four Stores",
			["#Job_crojob"] = 				"The Bomb: Forest",
			["#Job_crojob2"] = 				"The Bomb: Forest",
			["#Level_crojob3"] = 			"The Bomb: Forest",
			["#Job_kosugi"] = 				"Shadow Raid",
			["#Level_kosugi"] = 			"Shadow Raid",
			["#Job_hvh"] = 					"Cursed Kill Room",
			["#Level_hvh"] = 				"Cursed Kill Room",
			["#Job_nail"] = 				"Lab Rats",
			["#Level_nail"] = 				"Lab Rats",
			["#Job_dah"] = 					"Diamond Heist",
			["#Level_dah"] = 				"Diamond Heist",
			["#Job_mallcrasher"] = 			"Mallcrasher",
			["#Level_mallcrasher"] = 		"Mallcrasher",
			["#Job_bph"] = 					"Hell's Island",
			["#Level_bph"] = 				"Hell's Island",
			["#Job_nmh"] = 					"No Mercy",
			["#Level_nmh"] = 				"No Mercy Hospital",
			["#Job_vit"] = 					"The White House",
			["#Level_vit"] = 				"The White House",
			["#Job_mex_cooking"] = 			"Border Crystals",
			["#Level_mex_cooking"] = 		"Border Crystals",
			["#Job_mex"] = 					"Border Crossing",
			["#Level_mex"] = 				"Border Crossing",
			["#Job_bex"] = 					"San Martín Bank",
			["#Level_bex"] = 				"San Martín Bank",
			["#Job_pex"] = 					"Breakfast in Tijuana",
			["#Level_pex"] = 				"Breakfast in Tijuana",
			["#Job_fex"] = 					"Buluc's Mansion",
			["#Level_fex"] = 				"Buluc's Mansion",
			["#Job_chca"] = 				"Black Cat Heist",
			["#Level_chca"] =				"Black Cat Heist",
			["#Job_pent"] =					"Mountain Master",
			["#Level_pent"] =				"Mountain Master",
			["#Job_ranc"] =					"Midland Ranch",
			["#Level_ranc"] =				"Midland Ranch",
			["#Job_trai"] =					"Lost in Transit",
			["#Level_trai"] =				"Lost in Transit",
			["#Job_corp"] =					"Hostile Takeover",
			["#Level_corp"] =				"Hostile Takeover",
			["#Job_sand"] =					"The Ukrainian Prisoner",
			["#Level_sand"] =				"The Ukrainian Prisoner",
			
			--Custom Heists
			["#Job_zm_kino"] = 					"Kino Der Minetoten", 
			["#Level_zm_kino"] = 				"Kino Der Minetoten",
			["#Job_zm_house"] = 				"Zombie House",
			["#Level_zm_hox_3"] = 				"Zombie House",
			["#Job_broken_arrow2"] = 			"Broken Arrow",
			["#Level_zm_broken_arrow"] = 		"Broken Arrow",
			["#Job_zm_the_forest"] = 			"Wald Der Untoten",
			["#Level_zm_the_forest"] = 			"Wald Der Untoten",
			["#Job_Hoxton Breakout Zombies"] = 	"Zombie Breakout",
			["#Level_hox_2_zombie"] = 			"Zombie Breakout",
			["#Job_zm_arena"] = 				"Zombies Arena",
			["#Level_zm_arena"] = 				"Zombies Arena",
			["#Job_zm_dah"] = 					"Garnet Group Tower",
			["#Level_zm_dah"] = 				"Garnet Group Tower",
			["#Job_not_expected"] = 			"Stalk Fraud",		
			["#Level_thechase"] = 				"Stalk Fraud",
			["#Job_The Late Holiday Special"] = "The Late Holiday Special",
			["#Level_santa_pain"] = 			"The Late Holiday Special",
			["#Job_Virtual"] = 					"Ready Player None",
			["#Level_Victor Romeo"] = 			"Ready Player None",
			["#Job_Assault"] = 					"Bag Simulator: The Heist",
			["#Level_endless_assault"] = 		"Bag Simulator: The Heist",
			["#Job_colosseum"] = 				"Bag Simulator 2: The Rehashed Heist",
			["#Level_bag_sim_2"] = 				"Bag Simulator 2: The Rehashed Heist",
			["#Job_shovelforge"] = 				"Shovelforge Cook Off",
			["#Level_mc_shovelforge"] = 		"Shovelforge Cook Off",
			["#Job_mc_jewlerystore"] = 			"Jewelry Crafters",
			["#Level_mc_jewlerystore_lvl"] = 	"Jewelry Crafters",
			["#Job_mcparkour"] = 				"Simple Fun Platforming",
			["#Level_mcparkour"] = 				"Simple Fun Platofrming",
			["#Job_eclipse"] = 					"Project Eclipse", 
			["#Level_eclipse"] = 				"Project Eclipse",
			["#Job_eclipse_research_facility"] = "Project Eclipse: Eclipse Research Facility",
			["#Level_the_factory"] = 			"Project Eclipse: Eclipse Research Facility",
			["#Job_ascension"] = 				"Project Eclipse: Ascension",
			["#Level_ascension_III"] = 			"Project Eclipse: Ascension",
			["#Job_infinitebank"] = 			"First World Tower", 
			["#Level_infinitebank_room"] = 		"First World Tower",
			["#Job_heist_runner"] = 			"Diamond Runners",
			["#Level_pk_hcm"] = 				"Diamond Runners",
			["#Job_AnotherFourStores"] = 		"Four More Stores",
			["#Level_lvl_fourmorestores"] = 	"Four More Stores",
			["#Job_daymare"] = 					"Hells Nightmare",
			["#Level_daymare"] = 				"Hells Nightmare",
			["#Job_YouAreNeverAloneInTheDark"] = "Cargoship Raid",
			["#Level_Xanax"] = 					"Cargoship Raid",
			["#Job_Armsdeal Alleyway"] = 		"Armsdeal: Alleyway", 
			["#Level_amsdeal1"] = 				"Armsdeal: Alleyway",
			["#Job_modders_devmap"] = 			"Proving Grounds", 
			["#Level_modders_devmap"] = 		"Proving Grounds",
			["#Job_Election_Funds"] = 			"Election Funds", 
			["#Level_Election_Funds"] = 		"Election Funds",
			["#Job_tonisn1"] = 					"Grand Harvest", 
			["#Level_tonisl1"] = 				"Grand Harvest",
			["#Job_Underground_Bargains"] = 	"Underground_Bargains", 
			["#Level_Gambling_room"] = 			"Underground_Bargains",
			["#Job_hardware_store_wrapper"] = 	"Hardware Store", 
			["#Level_hardware_store"] = 		"Hardware Store",
			["#Job_family_jewels_wrapper"] = 	"Family Jewels", 
			["#Level_family_jewels"] = 			"Family Jewels",
			["#Job_red_money"] = 				"Red Money", 
			["#Level_red_money_stage_001"] = 	"Red Money",
			["#Job_hidden_vault"] = 			"Hidden Vault", 
			["#Level_hidden_vault"] = 			"Hidden Vault",
		}
		end
		
		if _G.SimpleRP:GetSimpleRP_language() == 2 then
			tokens = {
			["#raw_status"] =				"{#State_%game:state%}",

			-- Game states
			["#State_menu"] =				srp_mainmenu_text,
			["#State_private"] =			srp_private_text,
			["#State_lobby_no_job"] =		srp_lobby_text .. srp_sequence_lobby_filter,
			["#State_lobby"] =				srp_lobby_text .. "{#Mode_%game:mode%}",
			["#State_playing"] =			srp_playing_text .. "{#Mode_%game:mode%}",
			["#State_payday"] =				srp_payday_text .. "{#Mode_%game:mode%}",
			["#State_planning"] =			srp_planning_text .. "{#Mode_%game:mode%}",
			
			-- Game modes
			["#Mode_crime_spree"] =			srp_sequence_CS_filter,
			["#Mode_skirmish"] =			srp_sequence_HO_filter,
			["#Mode_heist"] =				srp_sequence_heist_filter,
			["#Mode_heist_chain"] =			srp_sequence_heistchain_filter,

			-- Difficulties
			["#Difficulty_easy"] =			srp_easy_text,
			["#Difficulty_normal"] =		srp_normal_text,
			["#Difficulty_hard"] =			srp_hard_tex,
			["#Difficulty_overkill"] =		srp_veryhard_text,
			["#Difficulty_overkill_145"] =	srp_overkill_text,
			["#Difficulty_easy_wish"] =		srp_mayhem_text,
			["#Difficulty_overkill_290"] =	srp_deathwish_text,
			["#Difficulty_sm_wish"] =		srp_deathsentence_text,
		}
		end
		
		local data = {
			["game:state"] = state,
			["game:mode"] = mode,
			["game:heist"] = heist,
			["game:heist_day"] = day,
			["game:difficulty"] = difficulty,
		}

		local s = string.format("{%s}", display or "#raw_status")

		local function populate_data(s, tokens, data, count)
			count = count or 1
			if count > 100 then
				log("Infinite loop in RP update!", "error")
				return s
			end

			if s:gmatch("%%(.+)%%") then
				for k, v in pairs(data or {}) do
					s = s:gsub("%%" .. k .. "%%", v)
				end
			end

			if s:gmatch("{(.+)}") then
				for k, v in pairs(tokens or {}) do
					local key = string.format("{%s}", k)
					if s:find(key) then
						s = s:gsub(key, populate_data(v, tokens, data, count + 1))
					end
				end
			end

			return s
		end

		s = populate_data(s, tokens, data)
		
		if managers.job:has_active_job() then
			if string.find(s, "{") then
				local job_data = managers.job:current_job_data()
				s = s:gsub('%{.-%}', "" .. managers.localization:text(job_data.name_id) .. " ")
		 	end
		end
	
		return s
	end
end

if Hooks then	-- Basegame doesn't update RP on peer count changes...
	Hooks:Add("BaseNetworkSessionOnPeerEnteredLobby", "BaseNetworkSessionOnPeerEnteredLobby_WolfHUD_RP", function(session, peer, peer_id)
		local session = managers.network:session()
		if session and Global.game_settings.permission ~= "private" then
			local group_count = tostring(session and #session:all_peers() or 1)
			Steam:set_rich_presence("steam_player_group_size", group_count)
		end
	end)

	Hooks:Add("BaseNetworkSessionOnPeerRemoved", "BaseNetworkSessionOnPeerRemoved_WolfHUD_RP", function(session, peer, peer_id, reason)
		local session = managers.network:session()
		if session and Global.game_settings.permission ~= "private" then
			local group_count = tostring(session and #session:all_peers() or 1)
			Steam:set_rich_presence("steam_player_group_size", group_count)
		end
	end)
end